﻿'Murmur Admin Console is a tool allowing the player administration of murmur servers
'Copyright (C) 2009  Matthew Minter (matt@masarand.com)

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Public Class ServerListManager

    Public Sub UpdateServerList(ByRef ListTo As System.Windows.Forms.ListBox)
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "/data/"
        ListTo.Items.Clear()
        Dim ServerListTmp As System.IO.StreamReader = My.Computer.FileSystem.OpenTextFileReader(datadir & "serverlist.txt")
        Dim ToServerList(0 To 0) As String
        Dim TempCurrentLine As String
        Dim ArraySize As Integer = 0
        While ServerListTmp.EndOfStream() <> True
            '
            TempCurrentLine = ServerListTmp.ReadLine()
            If TempCurrentLine.Contains("startserver ") = True Then
                '
                ReDim Preserve ToServerList(0 To ArraySize)
                TempCurrentLine = TempCurrentLine.Remove(0, 12)
                ToServerList(ArraySize) = TempCurrentLine
                ArraySize = ArraySize + 1
                '
            End If
            '
        End While
        If ToServerList(0) <> Nothing Then
            ListTo.Items.AddRange(ToServerList)
        End If
        ServerListTmp.Close()
    End Sub

    Public Sub AddServer(ByVal ServerLabel As String, ByVal ServerAddress As String, ByVal ServerUsername As String, ByVal ServerPort As Integer, ByVal ListTo As System.Windows.Forms.ListBox)
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "\data\"
        If ServerLabel <> "" And ServerAddress <> "" And ServerUsername <> "" And ListTo.Items.Contains(ServerLabel) <> True Then
            '
            Dim serverlistwriter As System.IO.StreamWriter = My.Computer.FileSystem.OpenTextFileWriter(datadir & "serverlist.txt", True)
            serverlistwriter.Write("startserver " & ServerLabel)
            serverlistwriter.WriteLine()
            serverlistwriter.Write("    address=" & ServerAddress)
            serverlistwriter.WriteLine()
            serverlistwriter.Write("    username=" & ServerUsername)
            serverlistwriter.WriteLine()
            serverlistwriter.Write("    port=" & ServerPort)
            serverlistwriter.WriteLine()
            serverlistwriter.Write("endserver " & ServerLabel)
            serverlistwriter.WriteLine()
            serverlistwriter.Flush()
            serverlistwriter.Close()
            UpdateServerList(ListTo)
            ListTo.SetSelected(ListTo.Items.Count - 1, True)
            '
        Else
            '
            FieldFill.ShowDialog()
            '
        End If
    End Sub

    Public Sub RemoveServer(ByVal ServerLabel As String, ByVal ServerList As System.Windows.Forms.ListBox)
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "\data\"
        Dim ServerListContents As String = My.Computer.FileSystem.ReadAllText(datadir & "serverlist.txt")
        Dim CurrentPos As Integer = ServerListContents.IndexOf("startserver " & ServerLabel)
        Dim EndPos As Integer = ServerListContents.IndexOf("endserver " & ServerLabel)
        Dim LastLine As String = "endserver " & ServerLabel
        Dim LastLineLength As Integer = LastLine.Length
        ServerListContents = ServerListContents.Remove(CurrentPos, EndPos - CurrentPos + LastLineLength + 2)
        My.Computer.FileSystem.WriteAllText(datadir & "serverlist.txt", ServerListContents, False)
        UpdateServerList(ServerList)
    End Sub

    Public Sub PopulateFields(ByVal ListItemFrom As String, ByVal LabelField As System.Windows.Forms.TextBox, ByVal AddressField As System.Windows.Forms.TextBox, ByVal PortField As System.Windows.Forms.TextBox, ByVal UsernameField As System.Windows.Forms.TextBox)
        Dim SelectedItem As String = ListItemFrom
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "/data/"
        Dim ServerListTmp As System.IO.StreamReader = My.Computer.FileSystem.OpenTextFileReader(datadir & "serverlist.txt")
        Dim TempCurrentLine As String = "ThisIsAPlaceholderLine"
        Dim TempUser As String
        Dim TempAddress As String
        Dim TempPort As String
        While TempCurrentLine.Length < 12 Or TempCurrentLine.Remove(0, 12) <> ListItemFrom
            '
            TempCurrentLine = ServerListTmp.ReadLine()
            '
        End While
        TempAddress = ServerListTmp.ReadLine.Remove(0, 12)
        TempUser = ServerListTmp.ReadLine.Remove(0, 13)
        TempPort = ServerListTmp.ReadLine.Remove(0, 9)
        LabelField.Text = ListItemFrom
        AddressField.Text = TempAddress
        UsernameField.Text = TempUser
        PortField.Text = TempPort
        ServerListTmp.Close()
    End Sub

End Class
